
def expr(brackets):

    res = ""
    for i in range(len(brackets) - 1):
        if brackets[i] == "(" and brackets[i + 1] == ")":
            res += "(1"
        elif brackets[i] == ")" and brackets[i + 1] == ")":
            res += ")+1"
        elif brackets[i] == ")" and brackets[i + 1] == "(":
            res += ")*"
        else:
            res += brackets[i]

    res += ")"
    return res


def brackets_out(expr):
    if expr[0] != "(":
        return False
    stack = 1

    for i in range(1, len(expr)):
        if expr[i] == "(":
            stack += 1
        elif expr[i] == ")":
            stack -= 1
        if stack == 0 and i != len(expr) - 1:
            return False
        if stack == 0 and i == len(expr) - 1:
            return True
    return False


def evaluate(expr):
    if brackets_out(expr):
        return evaluate(expr[1:len(expr) - 1])
    ones = 0
    if "*" not in expr:
        for item in expr:
            if item == "1":
                ones += 1
        return ones

    start = 0
    total = 0
    stack = 0
    last_sign = "+"
    for i in range(0, len(expr)):
        if expr[i] == "*" and stack == 0:
            last_sign = "*"
            start = i + 1
            continue
        elif expr[i] == "+" and stack == 0:
            last_sign = "+"
            start = i + 1
            continue
        elif expr[i] == "(":
            stack += 1
        elif expr[i] == ")":
            stack -= 1
        if stack == 0:
            res = evaluate(expr[start:i + 1])
            total = total + res if last_sign == "+" else total * res
    return total


if __name__ == "__main__":
    n = int(input())
    brackets = input()
    expression = expr(brackets)
    print(evaluate(expression))


