import sys

def do_check(which, desks, monitors):

    if monitors[which] > desks[which]:
        sys.stdout.write("monitors\n")
    elif desks[which] > monitors[which]:
        sys.stdout.write("desks\n")
    else:
        sys.stdout.write("same\n")

if __name__ == "__main__":

    line = [int(x) for x in sys.stdin.readline().rstrip("\n").split()]

    N, M, Q = line[0], line[1], line[2]

    desks = [int(x) for x in sys.stdin.readline().rstrip("\n").split()]
    monitors = [int(x) for x in sys.stdin.readline().rstrip("\n").split()]

    edges = [ [] for _ in range(N) ]

    for _ in range(M):
        line = [int(x) for x in sys.stdin.readline().rstrip("\n").split()]
        a, b = line[0], line[1]
        a -= 1
        b -= 1

        edges[a].append(b)
        edges[b].append(a)

    desks_2 = list(desks)
    monitors_2 = list(monitors)

    for u in range(len(edges)):
        for v in edges[u]:
            desks_2[u] += desks[v]
            monitors_2[u] += monitors[v]

    for _ in range(Q):

        query = sys.stdin.readline().rstrip("\n")

        tokens = query.split()

        if tokens[0] == "check":
            do_check(int(tokens[1]) - 1, desks_2, monitors_2)
        else:
            count = int(tokens[1])

            if tokens[2] == "desk":

                me = int(tokens[3]) - 1
                neigh = edges[ me ]
                desks_2[me] += count

                for nei in neigh:
                    desks_2[nei] += count

            else:
                me = int(tokens[3]) - 1
                neigh = edges[ me ]
                monitors_2[me] += count
                for nei in neigh:
                    monitors_2[nei] += count
